function Rf=GIBBS_ASSET_SIM(R_hist,ndraws, burn_in)



if nargin<2,    ndraws=50000;                                          end
if nargin<3,    burn_in=ndraws*0.1;                                  end

[nobs,dim]=size(R_hist);


%----------------------------------------

prior_mu=zeros(dim,1);
prior_V=10*eye(dim,dim);
prior_omega=eye(dim);
prior_df=dim+5;

%-----------------------------------------




betta=zeros(dim,ndraws);
sigma=zeros(dim,dim,ndraws);

betta(:,1)=mean(R_hist);
sigma(:,:,1)=cov(R_hist);
inv_sigma=inv(sigma(:,:,1));



inv_prior_V=inv(prior_V);
V_mu=inv_prior_V*prior_mu;
inv_prior_omega=inv(prior_omega);
R_sum=sum(R_hist)';


for m=2:ndraws
    
       
   
        
    D=nobs*inv_sigma+inv_prior_V; 
    d=(inv_sigma*R_sum+V_mu); 
    P=chol(D);
    beta_draw=D\d+P\randn(dim,1);
    betta(:,m)=beta_draw;
    
    
    
    resid_matrix=R_hist-beta_draw(:,ones(nobs,1))';
    RSS_matrix=resid_matrix'*resid_matrix;    
    post_omega=inv(inv_prior_omega+RSS_matrix);
    inv_sigma=WISHART_RND1(post_omega,nobs+prior_df);
    sigma(:,:,m)=inv(inv_sigma);
      
end

  
betta=betta(:,burn_in+1:ndraws);
sigma=sigma(:,:,burn_in+1:ndraws);



%------------------------
[dim,ndraws]=size(betta);

Rf=zeros(dim,ndraws);
for m=1:ndraws
   P=chol(sigma(:,:,m));
   Rf(:,m)=betta(:,m)+P'*randn(dim,1);
end

Rf_mean=mean(Rf,2);
Rf_std=std(Rf,0,2);


