function density=MVN_PDF(X,mu,sigma)



[dim,ndraws]=size(X);
dim_check=size(sigma,1);
if dim~=dim_check && ndraws==dim_check
    X=X';
    mu=mu';
    dim=ndraws;
end

if ndraws>1 && size(mu,2)==1
    mu=mu(:,ones(ndraws,1));    
end


constant=-0.5*dim*log(2*pi);

P=chol(sigma,'lower');
det_term=-sum(log(diag(P)));

X_trans=P\(X-mu);
exp_term=-0.5*sum(X_trans.*X_trans);

log_density=constant+det_term+exp_term;
density=exp(log_density);